	INCLUDE EFR32MG12.inc			; CPU register definitions	
		
	AREA    |.text|, CODE, READONLY	; another section in the CODE area	
;-------------------------------------------------------------------------------
GPIO_setup	PROC				; I/O Ports configuration
	EXPORT	GPIO_setup
	OORW	1<<3, CMU_HFBUSCLKEN0, CMU	; enable clock to GPIO
	OORW	4, GPIO_PD_MODEH, GPIO		; configure PD.8 for digital output	
	bx	LR
	ENDP	

;-------------------------------------------------------------------------------
LETIMER_setup	PROC
	EXPORT	LETIMER_setup
	PUTW	1, CMU_LFACLKEN0, CMU		; enable LFA clock for LETIMER
	PUTW	1<<9, LETIMERn_CTRL, LETIMER0	; set period	
	PUTW	32767, LETIMERn_COMP0		; 1 sec period
	PUTW	0x1F, LETIMERn_IFC		; clear all IF	
	PUTW	5, LETIMERn_CMD, LETIMER0	; start timer
	PUTW	4, LETIMERn_IEN			; enable posting UF flag to NVIC
	OORW	1<<27, 0, NVIC_ISER0		; enable LETIMER0 interrupts in NVIC
	bx	LR
	ENDP

;-------------------------------------------------------------------------------
I2C1_setup	PROC
	EXPORT	I2C1_setup
	OORW	1<<9, CMU_HFPERCLKEN0, CMU	; enable clock to I2C1
	OORW	0x88<<24, GPIO_PB_MODEL, GPIO	; configure PB.6,7 for open drain mode
	PUTW	(6<<8)+6, I2Cn_ROUTELOC0, I2C1	; set location 6 for I2C1
	PUTW	3, I2Cn_ROUTEPEN		; enable I2C1 pins
	PUTW	4, I2Cn_CLKDIV			; set 400 kbps rate
	PUTW	(1<<4)+1, I2Cn_CTRL		; enable I2C1 module
	bx	LR
	ENDP
		
	ALIGN
	END
	