	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions	
	INCLUDE	i2c.inc		
	INCLUDE	ccs811.inc	
	EXPORT	main
	IMPORT	GPIO_setup		; import names from other code files
	IMPORT	LETIMER_setup	
	IMPORT	I2C1_setup	
	IMPORT	co2
	IMPORT	tvoc	
				
CCS811_IRQ	EQU	1<<13				
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication
	bl	GPIO_setup		; configure port pins
;	bl	LETIMER_setup
	bl	I2C1_setup
	bl	CCS811_setup
	
loop					
	wfi
	bl	CCS811_get_data
;	bl	CCS811_request_conversion

	ldr	R1, =co2
	ldr	R0, =pT1
	bl	WriteString
	ldrh	R0, [R1]		; load CO2 data from RAM
	bl	WriteInt
	ldr	R0, =pT2
	bl	WriteString
	ldrh	R0, [R1, #2]		; load TVOC data form RAM
	bl	WriteInt
	ldr	R0, =pT3
	bl	WriteString
		
	b	loop			; repeat periodic task		
	ENDP

;--------------------------------------------------------------------
GPIO_ODD_IRQHandler PROC
	EXPORT	GPIO_ODD_IRQHandler		
	GETW	GPIO_IF, GPIO	
	ands	R1, #CCS811_IRQ
	str	R1, [R0, #GPIO_IFC]	; clear pin interrupt
	bx	LR
	ENDP
		
;--------------------------------------------------------------------
pT1	DCB	"CO2 = ", 0
pT2	DCB	" ppm      TVOC = ", 0
pT3	DCB	" ppb", 13, 10, 0
	ALIGN
	END